//
//  main.m
//  tests
//
//  Created by Andreas Gerlach on 9/22/12.
//  Copyright (c) 2012 Appelgriebsch. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ReflectionHelper/ReflectionHelper.h"
#import "JSonSerializer/JSONSerializer.h"
#import "Person.h"

int main(int argc, const char * argv[])
{
    
    @autoreleasepool {
        
        NSCalendarDate *dt = [NSCalendarDate dateWithYear:1965 month:10 day:10 hour:0 minute:0 second:0 timeZone:[NSTimeZone localTimeZone]];
        
        Person* p = [[Person alloc] initWithName:@"Mustermann" firstName:@"Max" birthdate:dt];
        Address* a = [[Address alloc] initWithAddressLine:@"Mr. Max Mustermann"
                                               streetName:@"Musterstr. 123"
                                                  zipCode:@"12345"
                                                     city:@"Musterstadt"];
        
        p.baseAddress = a;
        
        NSMutableSet *orders = [NSMutableSet set];
        
        for (int i = 0; i < 10; ++i) {
            
            Order *o = [[Order alloc] init];
            o.orderID = [NSString stringWithFormat:@"ORD_%d", (i + 1)];
            o.noOfItems = @(i + 1);
            o.itemAmnt = @((float)random() * 1000 / RAND_MAX * (i+1));
            o.discAmnt = @([o.itemAmnt floatValue] / 10);
            
            [orders addObject:o];
        }
        
        p.orders = orders;
        
        NSString *json = [JSONSerializer encodeAsString:p];
        
        NSLog(@"Person p(JSON): %@", json);
        
        Person *q = [JSONSerializer decodeString:json];
        
        NSLog(@"Person q: %@ living %@", q, q.baseAddress);
        
        for (Order *order in q.orders) {
            
            NSLog(@"Order: %@ #itm: %@ total: %@", order.orderID, order.noOfItems, @(order.itemAmnt.floatValue - order.discAmnt.floatValue));
        }
        
    }
    return 0;
}


