//
//  main.m
//  mongo-cli
//
//  Created by Andreas Gerlach on 10/26/12.
//  Copyright (c) 2012 Appelgriebsch. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <mongo-objc/mongo_objc.h>
#import "Person.h"

int main(int argc, const char * argv[])
{

    @autoreleasepool {
        
        MongoDB *mongoDB = [MongoDB connectTo:@"127.0.0.1" onPort:MONGO_DEFAULT_PORT];
        
        if ([mongoDB isConnected]) {
            
            NSLog(@"Connection succeeds!");
        }
        
        NSCalendarDate *dt = [NSCalendarDate dateWithYear:1965 month:10 day:10 hour:0 minute:0 second:0 timeZone:[NSTimeZone localTimeZone]];
        
        Person* p = [[Person alloc] initWithName:@"Mustermann" firstName:@"Max" birthdate:dt];
        Address* a = [[Address alloc] initWithAddressLine:@"Mr. Max Mustermann"
                                               streetName:@"Musterstr. 123"
                                                  zipCode:@"12345"
                                                     city:@"Musterstadt"];
        
        p.baseAddress = a;
        p.orders = [NSSet set];
        
        NSString *oid = [mongoDB storeDocument:p intoCollection:@"sample.people"];
        
        NSLog(@"Object stored w/ id: %@", oid);
        
        id object = [mongoDB retrieveObjectForDocument:oid fromCollection:@"sample.people"];
        
        NSLog(@"Restored object: %@", object);
        
        [mongoDB disconnect];
    }
    return 0;
}

