//
//  main.m
//  riak-cli
//
//  Created by Andreas Gerlach on 10/27/12.
//  Copyright (c) 2012 Appelgriebsch. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <riak-objc/riak_objc.h>
#import "Person.h"

int main(int argc, const char * argv[])
{

    @autoreleasepool {
        
        NSCalendarDate *dt = [NSCalendarDate dateWithYear:1965 month:10 day:10 hour:0 minute:0 second:0 timeZone:[NSTimeZone localTimeZone]];
        
        Person* p = [[Person alloc] initWithName:@"Mustermann" firstName:@"Max" birthdate:dt];
        Address* a = [[Address alloc] initWithAddressLine:@"Mr. Max Mustermann"
                                               streetName:@"Musterstr. 123"
                                                  zipCode:@"12345"
                                                     city:@"Musterstadt"];
        
        p.baseAddress = a;
        
        NSMutableSet *orders = [NSMutableSet set];
        
        for (int i = 0; i < 10; ++i) {
            
            Order *o = [[Order alloc] init];
            o.orderID = [NSString stringWithFormat:@"ORD_%d", (i + 1)];
            o.noOfItems = @(i + 1);
            o.itemAmnt = @((float)random() * 1000 / RAND_MAX * (i+1));
            o.discAmnt = @([o.itemAmnt floatValue] / 10);
            
            [orders addObject:o];
        }
        
        p.orders = orders;

        RiakServer *server = [RiakServer connectTo:@"127.0.0.1" onPort:8098];
        NSString *oid = [server storeDocument:p inBucket:@"people"];
        
        NSLog(@"Object stored w/ id: %@", oid);
        
        id restoredObject = [server retrieveDocument:oid fromBucket:@"people"];
        
        NSLog(@"Restored Object: %@", restoredObject);
        
    }
    return 0;
}

